unit camara1;

{$mode objfpc}{$H+}

interface

uses
  globales1,textomensajes,globales,capturador,Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  Buttons, ExtCtrls, StdCtrls, Menus;

type

  { TfrmCamara1 }

  TfrmCamara1 = class(TForm)
    Image1: TImage;
    imgCapturar: TImage;
    imgMostrar: TImage;
    imgVer: TImage;
    imlBotones: TImageList;
    imlIcono: TImageList;
    lblMensaje: TLabel;
    mnuNinguno: TMenuItem;
    mnuVerTodos: TMenuItem;
    poVer: TPopupMenu;
    SpeedButton1: TSpeedButton;

    procedure FormActivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure imgCapturarClick(Sender: TObject);
    procedure imgCapturarMouseEnter(Sender: TObject);
    procedure imgCapturarMouseLeave(Sender: TObject);
    procedure imgMostrarClick(Sender: TObject);
    procedure imgMostrarMouseEnter(Sender: TObject);
    procedure imgMostrarMouseLeave(Sender: TObject);
    procedure imgVerClick(Sender: TObject);
    procedure imgVerMouseEnter(Sender: TObject);
    procedure imgVerMouseLeave(Sender: TObject);
    procedure mnuNingunoClick(Sender: TObject);
    procedure mnuVerTodosClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    procedure AlumnoVer(ord_num: integer; mesa: string);
    procedure AlumnoVerNo();
    procedure CrearMenusVer();
    procedure menusverclick(Sender: TObject);
    procedure OcultarPresenta();
    procedure TodosPresentar();
    { private declarations }
  public
    { public declarations }
  end; 

var
  frmCamara1: TfrmCamara1;
  menusver:array of TMenuItem;
  menuNinguno:TmenuItem;


implementation
uses inicio;
{ TfrmCamara1 }
var
    f_mirando:boolean=false;

procedure TfrmCamara1.AlumnoVer(ord_num:integer;mesa:string);
    var
        i:integer;
    begin
        lblMensaje.visible:=true;
        g_tipoobservacion:=0;
        g_modoobservacion:=ord_num;
        for i:=0 to g_num_ord_aula -1 do
                equipoalumno[i].ver();
        lblMensaje.visible:=false;
    end;

procedure TfrmCamara1.menusverclick(Sender: TObject);
    var
        nombrem:string;
        numerom:integer;
    begin
        nombrem:=(sender as TmenuItem).Hint;
        numerom:=(sender as TmenuItem).Tag;
        AlumnoVer(numerom,nombrem);
    end;

procedure TfrmCamara1.CrearMenusVer();
    var
        i:integer;
    begin
        setlength(menusver,g_num_ord_aula);
        for i:= 0 to g_num_ord_aula-1 do
            begin
                menusver[i]:=Tmenuitem.create(self);
                with menusver[i] do
                    begin
                        tag:=i;
                        Caption:=equipoalumno[i].NombreMonitor;
                        Hint:=equipoalumno[i].NombreMonitor;
                        menusver[i].enabled:=false;
                        if equipoalumno[i].EstadoActivadEquipo <> eAveriado then
                            menusver[i].enabled:=true;
                        ImageIndex:=0;
                        OnClick:=@menusverclick;
                    end;
                poVer.items.add(menusver[i]);
            end;
    end;

procedure TfrmCamara1.AlumnoVerNo();
   var
      i:integer;
   begin
        for i:=0 to g_num_ord_aula -1 do
               equipoalumno[i].verNo();
   end;
procedure TfrmCamara1.OcultarPresenta();
    var
        i:integer;
    begin
       // lblMensaje.visible:=true;
        CerrarServidorVnc;
        application.ProcessMessages;
        iniciarServidorVNC();
      //  lblMensaje.visible:=false;
    end;

procedure TfrmCamara1.FormActivate(Sender: TObject);
    begin
        if frmMain.Visible then frmMain.hide;
    end;

procedure TfrmCamara1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
    begin
        if mensaje('¿Deseas salir de esta zona?',sino)=2 then
        begin
            canclose:=false;
            exit;
        end;
        OcultarPresenta();
    end ;

procedure TfrmCamara1.FormCreate(Sender: TObject);
    begin
        BorderStyle:=bsnone;
        CrearMenusVer;

        if g_MostrandoPantalla = 1 then
            begin
                imgMostrar.picture.bitmap.clear;
                imlbotones.GetBitmap(6,imgMostrar.Picture.Bitmap);
                imgmostrar.hint:='Ocultar a todos';
            end
        else
            begin
                imgMostrar.picture.bitmap.clear;
                imlbotones.GetBitmap(4,imgMostrar.Picture.Bitmap);
                imgmostrar.hint:='Mostrar a todos';
            end;
         Application.ProcessMessages;
    end;

procedure TfrmCamara1.imgCapturarClick(Sender: TObject);
    var
        capta:string;
    begin
         if (not directoryexists(equipoProfesor.DirCapturas)) then
            forcedirectories(equipoProfesor.DirCapturas);
        visible:=false;
        application.processmessages;
        capta:= 'scrot '+ equipoProfesor.ArcCaptura;
        Ejecutar(capta);
        application.processmessages;
        sleep(100);
        if fileexists(equipoProfesor.ArcCaptura) then
            TfrmCapturador.create(self).showmodal
        else
            mensaje(MEN_ERROR_CAPTURA,aceptar);
        imgCapturar.picture.bitmap.clear;
        imlbotones.GetBitmap(8,imgCapturar.Picture.Bitmap);
        visible:=true;
    end;

procedure TfrmCamara1.imgCapturarMouseEnter(Sender: TObject);
    begin
        imgCapturar.picture.bitmap.clear;
        imlbotones.GetBitmap(9,imgCapturar.Picture.Bitmap);
    end;

procedure TfrmCamara1.imgCapturarMouseLeave(Sender: TObject);
    begin
        if g_mostrandopantalla=0 then
            begin
                imgmostrar.picture.bitmap.clear;
                imlbotones.GetBitmap(4,imgmostrar.Picture.Bitmap);
            end
        else
            begin
                imgmostrar.picture.bitmap.clear;
                imlbotones.GetBitmap(6,imgmostrar.Picture.Bitmap);
            end
    end;

Procedure TfrmCamara1.TodosPresentar();
    var
        i:integer;
    begin
        lblMensaje.visible:=true;
        IniciarServidorVnc();
        application.ProcessMessages;
        for i:=0 to high(equipoalumno) do
            equipoalumno[i].mostrar();
        lblMensaje.visible:=false;
    end;

procedure TfrmCamara1.imgMostrarClick(Sender: TObject);
    begin
        if g_MostrandoPantalla = 0 then
            begin
                f_mirando:=true;
                imgverclick(imgver);
                g_MostrandoPantalla:=1;
                imgMostrar.picture.bitmap.clear;
                imlbotones.GetBitmap(6,imgMostrar.Picture.Bitmap);
                imgmostrar.hint:='Ocultar a todos';
                TodosPresentar
            end
        else
            begin
                g_MostrandoPantalla:=0;
                imgMostrar.picture.bitmap.clear;
                imlbotones.GetBitmap(4,imgMostrar.Picture.Bitmap);
                imgmostrar.hint:='Mostrar a todos';
                OcultarPresenta;
            end;
    end;

procedure TfrmCamara1.imgMostrarMouseEnter(Sender: TObject);
    begin
        if g_mostrandopantalla=0 then
            begin
                imgmostrar.picture.bitmap.clear;
                imlbotones.GetBitmap(5,imgmostrar.Picture.Bitmap);
            end
        else
            begin
                imgmostrar.picture.bitmap.clear;
                imlbotones.GetBitmap(7,imgmostrar.Picture.Bitmap);
            end
    end;

procedure TfrmCamara1.imgMostrarMouseLeave(Sender: TObject);
    begin
        if g_mostrandopantalla=0 then
            begin
                imgmostrar.picture.bitmap.clear;
                imlbotones.GetBitmap(4,imgmostrar.Picture.Bitmap);
            end
        else
            begin
                imgmostrar.picture.bitmap.clear;
                imlbotones.GetBitmap(6,imgmostrar.Picture.Bitmap);
            end
    end;


procedure TfrmCamara1.imgVerClick(Sender: TObject);
    begin
        f_mirando:=not f_mirando;
        if f_mirando then
            begin
                g_mostrandopantalla:=1;
                imgmostrarclick(imgmostrar);
                imgVer.picture.bitmap.clear;
                imlbotones.GetBitmap(2,imgver.Picture.Bitmap);
                AlumnoVer(-1,'Todos');
                imgver.hint:='Cerrar todos';
                imgver.showhint:=true;

            end
        else
            begin
                imgver.picture.bitmap.clear;
                imlbotones.GetBitmap(0,imgver.Picture.Bitmap);
                AlumnoVerNo;
                imgver.hint:='Ver todos';
            end;
    end;

procedure TfrmCamara1.imgVerMouseEnter(Sender: TObject);

    begin
        if f_mirando then
            begin
                imgVer.picture.bitmap.clear;
                imlbotones.GetBitmap(3,imgver.Picture.Bitmap);
            end
        else
            begin
                imgver.picture.bitmap.clear;
                imlbotones.GetBitmap(1,imgver.Picture.Bitmap);
            end
    end;

procedure TfrmCamara1.imgVerMouseLeave(Sender: TObject);
    begin
        if f_mirando then
            begin
                imgVer.picture.bitmap.clear;
                imlbotones.GetBitmap(2,imgver.Picture.Bitmap);
            end
        else
            begin
                imgver.picture.bitmap.clear;
                imlbotones.GetBitmap(0,imgver.Picture.Bitmap);
            end
    end;

procedure TfrmCamara1.mnuNingunoClick(Sender: TObject);
    begin
        f_mirando:=true;
        imgVerClick(imgVer);
    end;

procedure TfrmCamara1.mnuVerTodosClick(Sender: TObject);
    begin
        f_mirando:=false;
        imgVerClick(imgVer);
    end;

procedure TfrmCamara1.SpeedButton1Click(Sender: TObject);
    begin
         close;
    end;

initialization
  {$I camara1.lrs}

end.

