{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}

unit configurarprofesor;

{$mode objfpc}{$H+}

interface

uses
  IniFiles,Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

type

  { TfrmProgramas }
  Alcomando=record
        nombre:string;
        comando:string;
  end;
  RPosicionCuadros=record
        lCuadro:integer;
        tCuadro:integer;
        wCuadro:integer;
        hCuadro:integer;
  end;

  TfrmProgramas = class(TForm)
    btnRestaurar: TButton;
    btnSalir: TButton;
    cboEspecialidad: TComboBox;
    cboPresentaciones: TComboBox;
    cboNavegador: TComboBox;
    cboTextos: TComboBox;
    cboweb: TComboBox;
    cboVectorial: TComboBox;
    cboImagenes: TComboBox;
    edNombre: TEdit;
    Image1: TImage;
    pnAsignaturas: TPanel;
    procedure btnRestaurarClick(Sender: TObject);
    procedure btnSalirClick(Sender: TObject);
    procedure cboNavegadorChange(Sender: TObject);
    procedure cboNavegadorKeyPress(Sender: TObject; var Key: char);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
  private
    procedure CargarProgramasComandos();
    procedure ContenidoComandos();
    procedure CrearEditAsignaturas;
    procedure CrearEditComandos();
    procedure EscribirSetupProfe;
    procedure PosicionCuadros();
    procedure TextoCombos();
    function ValidarDatos(): boolean;
    { private declarations }
  public
    { public declarations }
  end; 

var
  frmProgramas: TfrmProgramas;
  edNombres:array [0..8] of Tedit;
  edComandos:array [0..8] of Tedit;
  edAsignaturas:Array[0..7] of Tedit;

implementation

{ TfrmProgramas }

uses globales,globales1, inicio;
Const
    NOMBRE_PROGRAMA:array [0..1,0..5]of string=(('Firefox','Espronceda','Macondo', 'Aliseda','Zurbarán','Alcantara'),
                                                 ('','','','', '',''));
    NOMBRE_COMANDO:array [0..1,0..5]of string=(('firefox','oowriter','ooweb', 'inkscape','gimp','ooimpress'),  ('','','','', '',''));
    MEN_INDICA_NOMBRE:string='Indica tu nombre';
    MEN_INDICA_ESPECIALIDAD:string='Indica tu especialidad';
    MEN_INDICA_COMANDO:string='Debes indicar el nombre y el comando de todos los programas. Si tienes dudas pulsa restaurar valores';
var
  f_PosicionNombres:array [0..8] of RPosicionCuadros;
function TfrmProgramas.ValidarDatos():boolean;
    var
        TextoMensaje:string;
        i:integer;
    begin
        TextoMensaje:='';
        if trim(ednombre.Text)='' then
            TextoMensaje:= MEN_INDICA_NOMBRE
        else if cboespecialidad.Text='' then
            TextoMensaje:=MEN_INDICA_ESPECIALIDAD;
        for i:=low(edcomandos) to high(edcomandos) do
            if sametext(edcomandos[i].text,'') or sametext(ednombres[i].text,'') then
                TextoMensaje:=MEN_INDICA_COMANDO;
        if TextoMensaje<>'' then
            mensaje(TextoMensaje,aceptar);
        result:= TextoMensaje='';
        application.ProcessMessages;
    end;

procedure TfrmProgramas.TextoCombos();
    begin
        cbonavegador.Text:='Navegador';
        cbotextos.Text:='Procesador textos';
        cboweb.Text:='Páginas web';
        cboimagenes.Text:='Editor Imágenes';
        cbovectorial.Text:='Diseño vectorial';
        cbopresentaciones.Text:='Presentaciones';
    end;

procedure TfrmProgramas.PosicionCuadros();
    var
        i:integer;
        lC,tC:integer;
    begin
        for i:= 0 to 8 do
            begin
                lC:= i mod 3;lC:=96+lC*288;
                tC:= i div 3;tC:= 351+tC*87;
                with f_PosicionNombres[i] do
                    begin
                        LCuadro:=lC;TCuadro:=tC;WCuadro:=178;HCuadro:=26;
                    end
            end ;
    end;

Procedure TfrmProgramas.EscribirSetupProfe;
    var
        MiFichero:TMeminiFile;
        i:integer;
        Asignatura,Programa,Comando:string;
    begin
        if not directoryexists(equipoProfesor.DirAulalinex)
            then mkdir(equipoProfesor.DirAulalinex);
        Mifichero:=TMeminifile.Create(equipoProfesor.ArcSetupProfe);
        with MIfichero do
            begin
                WriteString('Profesor','Nombre',edNombre.Text);
                WriteString('Profesor','Especialidad',cboEspecialidad.Text);
                for i:=low(edAsignaturas) to high(edAsignaturas) do
                    begin
                        asignatura:=edAsignaturas[i].Text;
                        WriteString ('Asignaturas','Asignatura_'+inttostr(i),Asignatura);
                    end;
                for i:=low(ednombres) to high(ednombres)  do
                    begin
                        Programa:=ednombres[i].Text;
                        WriteString ('Programas','Programa_'+inttostr(i),Programa);
                        Comando:=edcomandos[i].Text;
                        WriteString ('Comandos','Comando_'+inttostr(i),Comando);
                    end;
                UpdateFile;
                free;
            end;
    end;

procedure TfrmProgramas.CrearEditComandos();
    var
        i:integer;
    begin
        for i:=low(edNombres) to high(edNombres) do
            begin
                edNombres[i]:=Tedit.create(self);
                with edNombres[i] do
                    begin
                        text:='';
                        Cursor:=crHandPoint;
                        Font.Name:='Sans';
                        Font.size:=11;
                        Font.Style:=[fsbold];
                        SetBounds(f_PosicionNombres[i].lCuadro, f_PosicionNombres[i].tCuadro, f_PosicionNombres[i].wCuadro, f_PosicionNombres[i].hCuadro);
                        Visible:=true;
                        Parent:=self;
                        MaxLength:=30;
                        tag:=i;
                    end;
                edComandos[i]:=Tedit.create(self);
                with edComandos[i]do
                    begin
                        text:='';
                        Cursor:=crHandPoint;
                        Font.Name:='Sans';
                        Font.size:=11;
                        MaxLength:=30;
                        SetBounds(f_PosicionNombres[i].lCuadro, f_PosicionNombres[i].tCuadro +25, f_PosicionNombres[i].wCuadro, f_PosicionNombres[i].hCuadro);
                        Visible:=true;
                        Parent:=self;
                        tag:=i;
                    end;
            end
    end;

procedure TfrmProgramas.CrearEditAsignaturas;
    var
        i,lb,tb:integer;
    begin
        for i:=low(edAsignaturas) to high(edAsignaturas) do
            begin
                lb:=i mod 4;
                lb:=36+lb*206;
                tb:=i div 4;
                tb:=15 +tb*38;
                edAsignaturas[i]:=Tedit.create(self);
                with edAsignaturas[i] do
                    begin
                        text:='';
                        Cursor:=crHandPoint;
                        Font.Name:='Sans';
                        Font.size:=11;
                        SetBounds(lb,tb,167,27);
                        Visible:=true;
                        Parent:=pnAsignaturas;
                        MaxLength:=20;
                        tag:=i;
                    end;
            end;
    end;


procedure TfrmProgramas.ContenidoComandos();
    var
        i:integer;
    begin
        edNombre.Text:='Nombre';
        cboespecialidad.Text:='Especialidad';
        for i:= 0 to 5 do
            begin
                edNombres[i].text:=NOMBRE_PROGRAMA[0,i];
                edComandos[i].text:=NOMBRE_COMANDO[0,i];
            end;
        if edNombres[0].text='Grulla' then
            begin
                if fileexists('/usr/bin/firefox') then
                    edComandos[0].text:='firefox'
                else if  fileexists('/usr/bin/mozilla') then
                    edComandos[0].text:='mozilla'
                else
                    edComandos[0].text:='';
            end;
        edNombres[6].text:='Qcad';
        edNombres[7].text:='Kino';
        edNombres[8].text:='Cuzco';
        edComandos[6].text:='qcad';
        edComandos[7].text:='kino';
        edComandos[8].text:='xpdf';
        for i:= low(edAsignaturas) to high(edAsignaturas)  do
            edAsignaturas[i].text:='1ESOA-ASIG'+inttostr(i);
        for i:= 0 to controlcount-1 do
            begin
                if (controls[i] is Tcombobox) and   (((controls[i] as Tcombobox).Name)<>'cboEspecialidad') then
                    (controls[i] as Tcombobox).ItemIndex:=0;
            end;
        g_NombreProfe:='Mi Nombre';
        g_EspecialidaProfe:='Mi especialidad';
        for i:=low(ednombres) to high(ednombres) do
            begin
                g_NombreAplicacion[i]:= edNombres[i].text;
                g_ComandoAplicacion[i]:= edComandos[i].text
            end;
        for i:= low(edasignaturas) to high(edAsignaturas) do
            g_asignaprofe[i]:=edAsignaturas[i].text;
    end;

procedure TfrmProgramas.CargarProgramasComandos();
    var
        i:integer;
    begin
        ednombre.Text:=g_NombreProfe;
        cboEspecialidad.text:=g_EspecialidaProfe;
        for i:=low(ednombres) to high(ednombres) do
            begin
                edNombres[i].text:=g_NombreAplicacion[i];
                edComandos[i].text:= g_ComandoAplicacion[i]
            end;
        for i:=low(edAsignaturas) to high(edAsignaturas) do
            edAsignaturas[i].text:=g_asignaprofe[i];
        TextoCombos()
    end;

procedure TfrmProgramas.FormCreate(Sender: TObject);
    begin
        top:=13;left:=(screen.Width-width) div 2;
        PosicionCuadros();
        CrearEditAsignaturas();
        CrearEditComandos();
        if fileexists(equipoProfesor.ArcSetupProfe) then
            begin
                LeerSetupProfe();
                CargarProgramasComandos();
            end
        else
            ContenidoComandos();
    end;

procedure TfrmProgramas.btnRestaurarClick(Sender: TObject);
    begin
        CargarProgramasComandos();
    end;

procedure TfrmProgramas.btnSalirClick(Sender: TObject);
    begin
       close;
    end;

procedure TfrmProgramas.cboNavegadorChange(Sender: TObject);
    var
        nf,nc:integer;
    begin
        nc:=(sender as Tcombobox).Tag;
        nf:=(sender as Tcombobox).ItemIndex;
        edNombres[nc].text:=NOMBRE_PROGRAMA[nf,nc];
        edComandos[nc].text:=NOMBRE_COMANDO[nf,nc];
        if edNombres[0].text='Grulla' then
            begin
                if fileexists('/usr/bin/firefox') then
                    edComandos[0].text:= 'firefox'
                else if fileexists('/usr/bin/mozilla') then
                    edComandos[0].text:= 'mozilla'
                else
                    edComandos[0].text:=''
            end;
            TextoCombos();
    end;

procedure TfrmProgramas.cboNavegadorKeyPress(Sender: TObject; var Key: char);
    begin
        key:=#0;
    end;

procedure TfrmProgramas.FormActivate(Sender: TObject);
    begin
        if frmMain.Visible then frmMain.Hide;
    end;

procedure TfrmProgramas.FormClose(Sender: TObject; var CloseAction: TCloseAction
  );
    begin
       CloseAction:=cafree;
    end;

procedure TfrmProgramas.FormCloseQuery(Sender: TObject; var CanClose: boolean);
     begin
        if ValidarDatos() then
            begin
                EscribirSetupProfe();
                application.ProcessMessages;
                frmMain.Show;
                Hide;
            end
        else
        canclose:=false;
    end;


initialization
  {$I configurarprofesor.lrs}

end.

