{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit nombresalumnos; 

{$mode objfpc}{$H+}

interface

uses
  Math,inicio,globales,globales1,textomensajes,Classes, SysUtils, LResources,
  Forms, Controls, Graphics, Dialogs, ExtCtrls,  ComCtrls, StdCtrls;
type

  { TfrmNombresAlumnos }

  TfrmNombresAlumnos = class(TForm)
    btnAnadirCurso: TButton;
    btnAnadirGrupo: TButton;
    btnEliminarCurso: TButton;
    btnEliminarGrupo: TButton;
    btnLimpiarCurso: TButton;
    btnLimpiarGrupo: TButton;
    btnVolver: TButton;
    btnModificarCurso: TButton;
    btnModificarGrupo: TButton;
    edGrupo: TEdit;
    edCurso: TEdit;
    Image1: TImage;
    imlIcoDis: TImageList;
    Label3: TLabel;
    Label4: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    Label51: TLabel;
    Label52: TLabel;
    Label53: TLabel;
    lblCurso: TLabel;
    lstCursos: TListBox;
    lstGrupos: TListBox;
    procedure btnAnadirCursoClick(Sender: TObject);
    procedure btnAnadirGrupoClick(Sender: TObject);
    procedure btnEliminarCursoClick(Sender: TObject);
    procedure btnEliminarGrupoClick(Sender: TObject);
    procedure btnLimpiarCursoClick(Sender: TObject);
    procedure btnLimpiarGrupoClick(Sender: TObject);
    procedure btnModificarCursoClick(Sender: TObject);
    procedure btnModificarGrupoClick(Sender: TObject);
    procedure btnVolverClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lstCursosClick(Sender: TObject);
    procedure lstGruposClick(Sender: TObject);
  private
    procedure AnadirCurso;
    procedure AnadirGrupo(cur:integer);
    procedure CargarListaCursos();
    procedure CargarListaGrupos(aul: integer);
    procedure CargarListaGrupos();
    procedure CargarOrdenatas();
    procedure chkEquipoGrupoclick(sender: Tobject);
    procedure edalu1keypres(Sender: TObject; var Key: char);
    procedure EliminarCurso(cur: integer);
    procedure EliminarGrupo();
    procedure LimpiarCamposAlumnos();
    procedure LimpiarCamposGrupo();
    procedure ModificarCurso;
    procedure ModificarGrupo;
    procedure MostrarOrdenadores();
    procedure MostrarPersonal();
    function ValidarDatosCurso(): boolean;
    function ValidarDatosGrupo(cur: integer): boolean;
    { private declarations }
  public
    { public declarations }
  end; 

var
  frmNombresAlumnos: TfrmNombresAlumnos;
    Ordenata:Array of TImage;
    edAlu1:Array of Tedit;
    chkEquipoGrupo:Array of TCheckBox;

implementation

{ TfrmNombresAlumnos }
const
    W_ORDENADOR:integer=63;H_ORDENADOR:integer=58;

var
    fcurso,fgrupo:integer;
procedure TfrmNombresAlumnos.EliminarGrupo();
    var
        grupo:string;
        i:integer;
        grups:array of string;
    begin
        if (lstgrupos.Items.count=0) or (lstgrupos.ItemIndex=-1)  then
          begin
              mensaje(MEN_SELECCIONE_GRUPO, aceptar);
              exit;
          end;
        g_Cursos[fcurso].numerogrupos:=g_Cursos[fcurso].numerogrupos-1;
        SetLength(grups, g_Cursos[fcurso].numerogrupos);
        lstgrupos.Items.Delete(fgrupo);
        grupo:=lstgrupos.Items[lstgrupos.ItemIndex];
        for i:=0 to g_Cursos[fcurso].numerogrupos-1 do
           g_Cursos[fcurso].nombregrupos[i]:=lstGrupos.items[i];
        for i:=0 to g_num_ord_aula do
          if g_Cursos[fcurso].cgrupos[i] = fgrupo then
              g_Cursos[fcurso].cgrupos[i]:=-2;
        fgrupo:=-1;
        mensaje('el grupo '+ grupo +' ha sido eliminado',aceptar);
        btneliminarGrupo.Enabled:=false;
        btnModificarGrupo.Enabled:=false;
        LimpiarCamposGrupo();
     end;

procedure TfrmNombresAlumnos.ModificarGrupo;
    var
        i:integer;
    begin
        if (lstgrupos.Items.count=0) or (lstgrupos.ItemIndex=-1)  then
            begin
                mensaje(MEN_GRUPO_MODIFICAR, aceptar);
                exit;
            end;
        g_Cursos[fcurso].nombregrupos[lstGrupos.ItemIndex]:=edGrupo.text;
        lstGrupos.Items[lstGrupos.ItemIndex]:=edGrupo.text;
        for i:=0 to g_num_ord_aula-1 do
        begin
            if g_Cursos[fcurso].cgrupos[i] =fgrupo then
               g_Cursos[fcurso].cgrupos[i]:=-2;
            if chkEquipoGrupo[i].Checked then
               g_Cursos[fcurso].cgrupos[i]:=fgrupo;
        end;
        mensaje(MEN_GRUPO_MODIFICADO, aceptar);
    end;

procedure TfrmNombresAlumnos.LimpiarCamposGrupo();
    var
        i:integer;
    begin
        lstgrupos.itemindex:=-1;
        edgrupo.Text:='';
        for i:=0 to g_num_ord_aula-1 do
            chkEquipoGrupo[i].Checked:=false;
    end;

Function TfrmNombresAlumnos.ValidarDatosGrupo(cur:integer):boolean;
    var
        j,i:integer;
        TextoMensaje:string;
    begin
        TextoMensaje:='';
        if length(edgrupo.Text)<1 then
              TextoMensaje:=MEN_INDICA_NOMBRE
        else if length(lblcurso.Caption)<1 then
            TextoMensaje:=MEN_INDICA_AULA
        else
            begin
                j:=0;
                for i:= 0 to g_num_ord_aula-1 do
                    if chkEquipoGrupo[i].Checked then inc(j);
                if j=0 then
                    textomensaje:=MEN_SELECCIONA_EQUIPO;
            for i:=0 to g_Cursos[cur].numerogrupos -1 do
                begin
                    if g_Cursos[cur].nombregrupos[i]= edGrupo.Text then
                       textomensaje:=MEN_GRUPO_EXISTE;
                end;
            end;
        result:=TextoMensaje='';
        if not result then
            mensaje(TextoMensaje,aceptar);
    end;

procedure TfrmNombresAlumnos.AnadirGrupo(cur:integer);
    var
        i:integer;
        grup:integer;
    begin
        grup:=g_Cursos[cur].numerogrupos;
        g_Cursos[cur].numerogrupos:=g_Cursos[cur].numerogrupos+1;
        setlength(g_Cursos[cur].nombregrupos,g_Cursos[cur].numerogrupos);
        g_Cursos[cur].nombregrupos[grup]:=edGrupo.text;
        for i:=0 to g_num_ord_aula-1 do
            if chkEquipoGrupo[i].Checked then
               g_Cursos[cur].cgrupos[i]:=grup;
        CargarListaGrupos(cur);
        LimpiarCamposGrupo();
    end;
procedure TfrmNombresAlumnos.EliminarCurso(cur:integer);
    var
        curso:string;
        miscursos:array of Tcursos;
        i,j,z:integer;
    begin
        setlength(miscursos, g_NumCursos-1);
        j:=0;
        for i:=0 to g_NumCursos-1 do
            begin
                if i<>cur then
                    begin
                        miscursos[j].nombre:= g_Cursos[i].nombre;
                        miscursos[j].numeroalumnos:=g_Cursos[i].numeroalumnos;
                        miscursos[j].numerogrupos:= g_Cursos[i].numerogrupos;
                        setlength(miscursos[j].nombrealumnos,miscursos[j].numeroalumnos);
                        setlength(miscursos[j].nombregrupos,miscursos[j].numerogrupos);
                        setlength(miscursos[j].cgrupos,miscursos[j].numeroalumnos);
                        for z:=0 to miscursos[j].numeroalumnos -1 do
                            begin
                               miscursos[j].nombrealumnos[z]:=g_Cursos[i].nombrealumnos[z];
                               miscursos[j].cgrupos[z]:=g_Cursos[i].cgrupos[z]
                            end;
                        for z:=0 to miscursos[j].numerogrupos -1 do
                            begin
                               miscursos[j].nombregrupos[z]:=g_Cursos[i].nombregrupos[z];
                            end;
                        j:=j+1;
                    end;
            end;
        fcurso:=-1;
        g_NumCursos:=g_NumCursos-1;
        SetLength(g_Cursos,g_NumCursos);
        g_Cursos:=miscursos;
        lstCursos.Items.Delete(lstCursos.itemindex);
        curso:=lstCursos.Items[lstCursos.itemindex];
        mensaje('el curso '+ curso +' ha sido eliminado',aceptar);
        btneliminarCurso.Enabled:=false;
        btnModificarCurso.Enabled:=false;
        cargarlistaCursos();
        LimpiarCamposAlumnos();
    end;

procedure TfrmNombresAlumnos.ModificarCurso;
    var
        curso:string;
        i:integer;
    begin
        if (lstCursos.Items.count=0) or (lstCursos.ItemIndex=-1)  then    exit;
        curso:=edCurso.text;
        if mensaje('¿Desea modificar el curso ' +curso+'?',sino)=2 then    exit;
        lstCursos.Items[fcurso]:=curso;
        g_Cursos[fcurso].nombre:=curso;
        for i:=0 to g_num_ord_aula-1 do
           g_Cursos[fcurso].nombrealumnos[i]:=edAlu1[i].text;
        mensaje('El curso ' + edcurso.Text + ' ha sido modificado correctamente',aceptar);
    end;

Function TfrmNombresAlumnos.ValidarDatosCurso():boolean;
    var
        TextoMensaje:string;
    begin
        if length(trim(edCurso.text)) <1 then
            TextoMensaje:=MEN_ELIGE_NOMBRE
        else
            TextoMensaje:='';
        result:=TextoMensaje='';
        if not result then
            mensaje(TextoMensaje,aceptar);
    end;

procedure TfrmNombresAlumnos.LimpiarCamposAlumnos();
    var
        i:integer;
    begin
        lstcursos.itemindex:=-1;
        lstgrupos.Clear;
        edgrupo.Text:='';
        edCurso.text:='';
        lblcurso.caption:='';
        for i:=0 to g_num_ord_aula-1 do
            begin
                chkEquipoGrupo[i].Checked:=false;
                edalu1[i].text:='';
            end;
        btnEliminarCurso.Enabled:=false;
        btnEliminargrupo.Enabled:=false;
        btnModificargrupo.Enabled:=false;
        btnModificarcurso.Enabled:=false;
    end;

procedure TfrmNombresAlumnos.AnadirCurso;
    var
       nc,i:integer;
    begin
        g_NumCursos:=g_NumCursos+1;
        SetLength(g_Cursos,g_NumCursos);
        nc:=g_NumCursos-1;
        g_Cursos[nc].nombre:=edCurso.text;
        g_Cursos[nc].numeroalumnos:=g_num_ord_aula;
        g_Cursos[nc].numerogrupos:=0;
        SetLength(g_Cursos[nc].nombrealumnos,g_num_ord_aula);
        SetLength(g_Cursos[nc].cgrupos,g_num_ord_aula);
        for i:=0 to g_num_ord_aula-1 do
        begin
           g_Cursos[nc].nombrealumnos[i]:=edAlu1[i].text;
           g_Cursos[nc].cgrupos[i]:=-2;
        end;
        cargarlistaCursos();
        LimpiarCamposAlumnos();
    end;

procedure TfrmNombresAlumnos.CargarListaCursos();
    var i:integer;
    begin
        if g_NumCursos=0 then exit;;
        lstCursos.Clear;
        for i:=0 to g_NumCursos-1 do
            lstcursos.Items.Add(g_Cursos[i].nombre);
    end;

procedure TfrmNombresAlumnos.CargarListaGrupos();
    var
        i:integer;
    begin
        lstgrupos.Clear;
        if g_Cursos[fcurso].numerogrupos=0 then exit;
        for i:=0 to g_Cursos[fcurso].numerogrupos-1 do
            lstgrupos.Items.Add(g_Cursos[fcurso].nombregrupos[i]);
    end;

procedure TfrmNombresAlumnos.chkEquipoGrupoclick(sender:Tobject);
    var
        inumima,inumord:integer;
    begin
        inumord:=(sender as TCheckBox).tag;
        inumima:=ifthen((sender as TCheckBox).Checked,1,0);
        imlIcoDis.GetBitmap(inumima,Ordenata[inumord].Picture.Bitmap)
    end;

Procedure TfrmNombresAlumnos.MostrarOrdenadores();
    const
        tor:integer=530;
        wo:integer=63;ho:integer=58;
    var
       lor,sepl,lb,tb,spt,i,numsep,numfilas:integer;
       posi3,posi2,cambioi:integer;
    begin
        sepl:=ifthen(g_numero_columnas=3,150,260);
        if g_TipoClase=1then
            begin
                cambioi:=1;posi3:=480;posi2:=500;
            end
        else
            begin
                cambioi:=-1;posi3:=780;posi2:=760;
            end;
        lor:=ifthen(g_numero_columnas=3,posi3,posi2);
        numfilas:=(g_num_ord_pantalla div g_numero_columnas);
        numsep:=numfilas -1;
        spt:=(530-(numfilas*58)) div numsep;
        for i:=g_num_ord_pantalla-1 downto 0  do
            begin
                tb:= i div g_numero_columnas;tb:= tor-tb*(59+spt);
                lb:= i mod g_numero_columnas;lb:= lor+cambioi*lb*sepl;
                Ordenata[i].SetBounds(lb,tb,wo,ho);
                Ordenata[i].visible:=true;
            end;
    end;

Procedure TfrmNombresAlumnos.MostrarPersonal();
    var
        i:integer;
    begin
        for i:=0 to high(Ordenata) do
            Ordenata[i].visible:=false;
        for i:=0 to g_num_ord_aula-1 do
            begin
                Ordenata[i].SetBounds(equipoalumno[i].L,equipoalumno[i].T+10,58,51);
                Ordenata[i].Visible:=true;
            end;
    end;

Procedure TfrmNombresAlumnos.CargarOrdenatas();
    var
        fuente,altoe,i:integer;
    begin
        setlength(Ordenata,g_num_ord_pantalla);
        setlength(edalu1,g_num_ord_pantalla);
        setlength(chkEquipoGrupo,g_num_ord_pantalla);
        for i:=g_num_ord_pantalla-1 downto 0 do
            begin
                Ordenata[i]:= TImage.Create(self);
                with Ordenata[i] do
                    begin
                        width:=W_ORDENADOR;
                        Height:=H_ORDENADOR;
                        stretch:=true;
                        Cursor:=crarrow;
                        imlicodis.GetBitmap(0,Picture.Bitmap);
                        Parent:=self;
                        tag:=i;
                        visible:=false;
                        if i<g_num_ord_aula then
                            if equipoAlumno[i].EstadoActivadEquipo=eAveriado then
                                enabled:=false;
                    end;
            end;
        if g_DisenoClase=0 then
            MostrarOrdenadores
        else
            MostrarPersonal;
        if g_num_ord_aula>18 then
            begin
            fuente:=9;altoe:=18
            end
        else
            begin
            fuente:=9;altoe:=18;
            end;

        for i:= 0 to g_num_ord_pantalla-1 do
            begin
                edalu1[i]:= Tedit.Create(self);
                with edalu1[i] do
                    begin
                        Visible:=true;
                        SetBounds(Ordenata[i].Left-22, (Ordenata[i].top+Ordenata[i].height),(Ordenata[i].Width +44),altoe);
                        Font.Name:='Sans';
                        Font.Size :=fuente;
                        maxlength:=22;
                        BorderStyle:=bssingle;
                        Parent:=self;
                        visible:=false;
                        OnKeyPress:=@edalu1keypres;
                        if (i<g_num_ord_aula) and not g_GrupoPertenece then
                            begin
                                with equipoalumno[i] do
                                    begin
                                        if (leftstr(NombreMonitor,4)<>'Mesa')then
                                            text:=leftstr(NombreMonitor,11);
                                    end;
                            end;
                    end;
            end;
        for i:=g_num_ord_aula to g_num_ord_pantalla-1 do
            begin
                edalu1[i].visible:=false;
                ordenata[i].Visible:=false;
            end;
        for i:= 0 to g_num_ord_pantalla-1 do
            begin
                edalu1[i].TabOrder:=8+i;
            end;
        for i:= 0 to g_num_ord_aula-1 do
            begin
                  chkEquipoGrupo[i]:= TCheckBox.Create(self);
                  with chkEquipoGrupo[i] do
                      begin
                          Checked:=false;
                          Visible:=true;
                          SetBounds(Ordenata[i].Left+Ordenata[i].Width+2,Ordenata[i].Top,15,15);
                          Caption:='';
                          Parent:=self;
                          tag:=i;
                          Cursor:=crHandPoint;
                          OnClick:=@chkEquipoGrupoclick;
                          Enabled:=true;
                          visible:=false;;
                      end;
            end;
        for i:=0 to g_num_ord_aula-1 do
            begin
               chkEquipoGrupo[i].Visible:=true;
               Ordenata[i].Visible:=true;
               edAlu1[i].Visible:=true;
            end;
    end;

procedure TfrmNombresAlumnos.edalu1keypres(Sender: TObject; var Key: char);
    begin
        if key=',' then  key:=#0;
    end;

procedure TfrmNombresAlumnos.FormCreate(Sender: TObject);
    begin
        top:=13;
        left:=(screen.Width-width) div 2;
        CargarOrdenatas();
    end;

procedure TfrmNombresAlumnos.FormShow(Sender: TObject);
    begin
        CargarListaCursos();
    end;

procedure TfrmNombresAlumnos.FormActivate(Sender: TObject);
    begin
        if frmMain.Visible then frmMain.Hide;
    end;

procedure TfrmNombresAlumnos.btnVolverClick(Sender: TObject);
    begin
       close;
    end;

procedure TfrmNombresAlumnos.btnAnadirCursoClick(Sender: TObject);
    var
        grupoexiste:boolean;
        i:integer;
    begin
        grupoexiste:=false;
        if ValidarDatosCurso then
            begin
                for i:=0 to High(g_Cursos) do
                      if edCurso.text = g_Cursos[i].nombre then
                         grupoexiste:=true;
                if grupoexiste then
                    mensaje('El curso ' + edCurso.text + ' ya existe. Haz clic en modificar si deseas realizar algún cambio',aceptar)
                else
                    AnadirCurso;
            end;
    end;

procedure TfrmNombresAlumnos.btnAnadirGrupoClick(Sender: TObject);
    begin
        if ValidarDatosGrupo(fcurso) then
                AnadirGrupo(fcurso);
    end;

procedure TfrmNombresAlumnos.btnEliminarCursoClick(Sender: TObject);
    begin
        EliminarCurso(fcurso)
    end;

procedure TfrmNombresAlumnos.btnEliminarGrupoClick(Sender: TObject);
    begin
        EliminarGrupo
    end;

procedure TfrmNombresAlumnos.btnLimpiarCursoClick(Sender: TObject);
    begin
        LimpiarCamposAlumnos;
    end;

procedure TfrmNombresAlumnos.btnLimpiarGrupoClick(Sender: TObject);
    var
        i:integer;
    begin
        lstgrupos.ItemIndex:=-1;
        edgrupo.Text:='';
        for i:=0 to g_num_ord_aula-1 do
            chkEquipoGrupo[i].Checked:=false;
    end;

procedure TfrmNombresAlumnos.btnModificarCursoClick(Sender: TObject);
    begin
        if lstcursos.ItemIndex=-1 then
            mensaje(MEN_SELECCIONE_CURSO,aceptar)
        else
            ModificarCurso
    end;

procedure TfrmNombresAlumnos.btnModificarGrupoClick(Sender: TObject);
    begin
       ModificarGrupo;
    end;

procedure TfrmNombresAlumnos.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
    begin
         CloseAction:=cafree;
    end;

procedure TfrmNombresAlumnos.FormCloseQuery(Sender: TObject;
  var CanClose: boolean);
    begin
        if mensaje(MEN_SALIR_ZONA,sino)=2 then
             canclose:=false
        else
            begin
               EscribirficheroCursos;
               application.ProcessMessages;
               frmMain.CargarGruposAlumnos;
               frmMain.show;
               hide;
            end;
    end;

procedure TfrmNombresAlumnos.lstcursosClick(Sender: TObject);
    var
        micurso:string;
       i:integer;
    begin
        if lstcursos.itemindex=-1 then exit;
        micurso:=lstcursos.Items[lstcursos.itemindex];
        fcurso:=lstcursos.itemindex;
        edCurso.text:=micurso;
        lblcurso.caption:=micurso;
        for i:=0 to g_num_ord_aula-1 do
            begin
                chkEquipoGrupo[i].Checked:=false;
                if i< g_Cursos[fcurso].numeroalumnos then
                      edAlu1[i].Text:= g_Cursos[fcurso].nombrealumnos[i];
            end;
        btnEliminarCurso.Enabled:=true;
        btnModificarCurso.Enabled:=true;
        CargarListaGrupos(fcurso);
    end;

procedure TfrmNombresAlumnos.lstGruposClick(Sender: TObject);
    var
        migrupo:string;
        i:integer;
    begin
        if lstgrupos.itemindex=-1 then exit;
        migrupo:=lstgrupos.Items[lstgrupos.itemindex];
        fgrupo:=lstgrupos.itemindex;
        edgrupo.Text:=migrupo;
        for i:=0 to g_num_ord_aula-1 do
            begin
                chkEquipoGrupo[i].Checked:=false;
                if i< g_Cursos[fcurso].numeroalumnos then
                    if g_Cursos[fcurso].cgrupos[i]=fgrupo then
                      chkEquipoGrupo[i].Checked:=true;
            end;
        btnEliminarGrupo.Enabled:=true;
        btnModificarGrupo.Enabled:=true;
    end;

procedure TfrmNombresAlumnos.CargarListaGrupos(aul:integer);
    var
       i:integer;
    begin
        lstgrupos.Clear;
        if g_Cursos[aul].numerogrupos = 0 then exit;
        for i:=0 to g_Cursos[fcurso].numerogrupos -1 do
            lstgrupos.Items.Add(g_Cursos[aul].nombregrupos[i]);
    end;

initialization
  {$I nombresalumnos.lrs}

end.

