{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit procesos;

{$mode objfpc}{$H+}

interface

uses
  globales,globales1,textomensajes,Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Buttons, Process;

type

  { TfrmProcesos }

  TfrmProcesos = class(TForm)
    btnCapturar: TButton;
    btnSalir: TButton;
    btnRefrescar: TButton;
    btnGuardar: TButton;
    imlOrd: TImageList;
    imgF: TImage;
    Label1: TLabel;
    lstProcesos: TListBox;
    SaveDialog1: TSaveDialog;
    procedure btnCapturarClick(Sender: TObject);
    procedure btnGuardarClick(Sender: TObject);
    procedure btnRefrescarClick(Sender: TObject);
    procedure btnSalirClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
  private
    procedure CrearEtiquetasOr();
    procedure CrearOrdenadores();
    procedure MostrarOrdenadores(numaula, numpan: integer);
    procedure MostrarPersonal();
    function NombresProgramas(frase: string): string;
    procedure OrdConclic(Sender: TObject);
    { private declarations }
  public
    { public declarations }
  end; 

var
  frmProcesos: TfrmProcesos;
  OrdCon:array[0..23] of TSpeedButton;
  lblOrd:array[0..23] of Tlabel;

implementation
uses inicio;
var
    f_numord:integer;
{ TfrmProcesos }
procedure TfrmProcesos.CrearEtiquetasOr();
    var
        i:integer;
    begin
        for i:= low(lblOrd) to high(lblOrd) do
            begin
                lblOrd[i]:=Tlabel.Create(self);
                with lblOrd[i] do
                    begin
                        tag:=i;
                        Color:=clwhite;
                        transparent:=true;
                        autosize:=false;
                        alignment:=tacenter;
                        font.Name:='Sans';
                        font.Size:=10;
                        layout:=tlcenter;
                        Visible:=false;
                        if i< g_num_ord_aula then
                            begin
                                Enabled:=equipoalumno[i].EstadoActivadEquipo <>eAveriado;
                                caption:=equipoalumno[i].NombreMonitor;
                                if caption='' then caption :='Mesa '+ inttostr(i+1);
                            end;
                        Cursor:=crarrow;
                        Parent:=self;
                    end;
            end
    end;

Procedure TfrmProcesos.MostrarPersonal();
    var
        i:integer;
    begin
        for i:=0 to high(ordcon) do
            ordcon[i].visible:=false;
        for i:=0 to g_num_ord_aula-1 do
           begin
               ordcon[i].SetBounds(equipoalumno[i].L,equipoalumno[i].T+15,66,61);
               ordcon[i].Visible:=true;
               with lblOrd[i]do
                  begin
                      SetBounds(ordcon[i].Left-23,ordcon[i].top+ordcon[i].height+1,ordcon[i].Width+47,15);
                      visible:=true;
                  end;
           end;
    end;

Procedure TfrmProcesos.MostrarOrdenadores(numaula,numpan:integer);
    const
        tor:integer=520;
        wo:integer=66;ho:integer=61;
    var
        lor,sepl,lb,tb,spt,i,numsep,numfilas:integer;
        posi3,posi2,cambioi:integer;
    begin
        if g_numero_columnas=3 then
            sepl:=150
        else
            sepl:=260;
        application.ProcessMessages;
        if g_TipoClase=1 then
            begin
                cambioi:=1;posi3:=480;posi2:=500;
            end
        else
            begin
                cambioi:=-1;posi3:=780;posi2:=760;
            end;
        if g_numero_columnas=3 then
            lor:=posi3
        else
            lor:=posi2;
        numfilas:=(numpan div g_numero_columnas);
        numsep:=numfilas -1;
        spt:=(510-(numfilas*63)) div numsep;
        for i:=numaula-1 downto 0  do
            begin
                tb:= i div g_numero_columnas;tb:= tor-tb*(63+spt);
                lb:= i mod g_numero_columnas;lb:= lor+ cambioi*lb*sepl;
                with ordcon[i] do
                    begin
                       SetBounds(lb,tb,wo,ho);
                       visible:=true;
                    end;
                with lblOrd[i]do
                    begin
                        SetBounds(ordcon[i].Left-23,ordcon[i].top+ordcon[i].height+1,ordcon[i].Width+47,15);
                        visible:=true;
                    end;
            end;
    end;

Function TfrmProcesos.NombresProgramas(frase:string):string;
    const
        COMANDOS:array[0..13] of string=('abiword','x0rfbserver','firefox-bin','gnumeric','nautilus',
        'soffice.bin','gimp-2.0','gedit','gcalctool','inkscape','dia-gnome','xchat',
        'gaim','quextalumno-bin');
        PROGRAMAS:array[0..13] of string=('Brocense (Procesador de Textos)','Servidor VNC'
        ,'Grulla (Mozilla Firefox)','Cáparra (Hoja de cálculo)','Nautilus(Explorador)'
        ,'OpenOffice.org (Ofimática)','Zurbaran(Gimp, Diseño gráfico)','Diana(Bloc de notas)'
        ,'Calculadora','Aliseda(Dibujo vectorial)','Morales(Diagramas vectoriales)'
        ,'Aliseda (Chat IRC: xchat)','Terrona(Mensajería mns)','QuExt(Entorno educativo)');
    var
        neofrase:string;
        i:integer;
    begin
        neofrase:=frase;
        for i:= low(COMANDOS) to high(COMANDOS) do
            neofrase:=StringReplace(neofrase,COMANDOS[i],PROGRAMAS[i],[rfReplaceAll]);
        result:=neofrase;
    end;

procedure TfrmProcesos.btnSalirClick(Sender: TObject);
    begin
        close;
    end;

procedure TfrmProcesos.FormActivate(Sender: TObject);
    begin
        if frmMain.Visible then frmMain.hide;
    end;

procedure TfrmProcesos.FormClose(Sender: TObject; var CloseAction: TCloseAction);
    begin
        CloseAction:=cafree;
    end;

procedure TfrmProcesos.FormCloseQuery(Sender: TObject; var CanClose: boolean);
    begin
        if mensaje(MEN_SALIR_ADMIN,sino)=2 then
            canclose:=false
        else
            begin
                frmMain.show;
                hide;
            end;
    end;

procedure TfrmProcesos.FormCreate(Sender: TObject);
    begin
        top:=13;left:=(screen.Width-width)div 2;
        CrearOrdenadores;
        CrearEtiquetasOr;
        if g_DisenoClase=0 then
            MostrarOrdenadores(g_num_ord_aula ,g_num_ord_pantalla)
        else
            MostrarPersonal;
    end;

procedure TfrmProcesos.CrearOrdenadores();
    var
        i:integer;
    begin
        for i:= low(ordcon) to high(ordcon) do
            begin
                ordcon[i]:=TSpeedButton.Create(self);
                with ordcon[i] do
                    begin
                        tag:=i;
                        Color:=clwhite;
                        AllowAllUp:=true;
                        Visible:=false;
                        imlord.GetBitmap(0,Glyph);
                        GroupIndex:=101;
                        NumGlyphs:=4;
                        if i< g_num_ord_aula then
                            Enabled:=equipoAlumno[i].EstadoActivadEquipo in [eEncendido,eUsuario];
                        onclick:=@ordconclic;
                        Cursor:=crhandpoint;
                        Parent:=self;
                    end;
            end;
    end;

procedure TfrmProcesos.OrdConclic(Sender: TObject);
    var
        A:TStringList;
        i:integer;
        datosusuario:string;
        procesos:string;
    begin
        f_numord:=(sender as TSpeedButton).Tag;
        if (not (equipoAlumno[f_numord].EstadoActivadEquipo in [eUsuario])) then
            begin
                mensaje(MEN_NO_USUARIO,aceptar);
                exit;
        end;
        lstProcesos.Clear;
        procesos:=equipoalumno[f_numord].ObtenerProcesos();
        btnCapturar.Enabled:=true;
        btnGuardar.Enabled:=true;
        A:=TStringList.create;
        try
            A.Text:=procesos;
            datosusuario:='DATOS DEL ALUMNO';
            lstProcesos.items.Add(datosusuario);
            datosusuario:='Nombre equipo: ' + equipoalumno[f_numord].IP +'. Usuario: ' + equipoalumno[f_numord].UsuarioActivo;
            lstProcesos.items.Add(datosusuario);
            datosusuario:='Fecha: '+datetostr(date)+ ', Hora: '+timetostr(time);
            lstProcesos.items.Add(datosusuario);
            for i:=0 to A.Count-1 do
                lstProcesos.items.Add(A.Strings[i]);
        finally
            A.free;
        end
   end;

procedure TfrmProcesos.btnRefrescarClick(Sender: TObject);
    var
        i:integer;
    begin
        if mensaje(MEN_REFRESCAR,sino)=2 then  exit;
           cursor:=crHourGlass;
        try
            for i:=0 to g_num_ord_aula -1 do
                begin
                    lblOrd[i].caption:=equipoalumno[i].NombreMonitor;
                    if lblOrd[i].Caption='' then lblOrd[i].Caption:= 'Mesa '+inttostr(i+1);
                    ordcon[i].Enabled:=(equipoAlumno[i].EstadoActivadEquipo in [eEncendido,eUsuario]);
                end;
        finally
            begin
                cursor:=crarrow;
            end;
        end;
    end;

procedure TfrmProcesos.btnGuardarClick(Sender: TObject);
    begin
        if savedialog1.Execute then
            lstProcesos.items.SaveToFile(savedialog1.filename)
    end;

procedure TfrmProcesos.btnCapturarClick(Sender: TObject);
     begin
        g_tipoobservacion:=0;
        g_modoobservacion:=f_numord;
        equipoAlumno[f_numord].ver();
        application.ProcessMessages;
        Application.ProcessMessages;
        Ejecutar('gnome-screenshot --delay 1');
        equipoAlumno[f_numord].verNo();
    end;



initialization
  {$I procesos.lrs}

end.

