unit demonio ;

{$mode objfpc}{$H+}

interface 

uses 
  clservidor,globales,Classes , SysUtils , FileUtil , LResources , Forms , Controls , Dialogs ,
  IdCmdTCPServer, IdCommandHandlers, IdContext, IdURI;

type 

  { TDataModule1 }

  TDataModule1 = class (TDataModule )
    IdCmdTCPServer1 : TIdCmdTCPServer ;
    procedure activarInternetCommand (ASender : TIdCommand );
    procedure apagarEquipoCommand (ASender : TIdCommand );
    procedure desactivarInternetCommand (ASender : TIdCommand );
    procedure ejecutarOrdenCommand(ASender: TIdCommand);
    procedure hallarConsolaCommand(ASender: TIdCommand);
    procedure hallarGatewayCommand (ASender : TIdCommand );
    procedure hallarHostCommand(ASender: TIdCommand);
    procedure hallarHostMacCommand(ASender: TIdCommand);
    procedure hallarIPCommand (ASender : TIdCommand );
    procedure hallarMACCommand (ASender : TIdCommand );
    procedure IdCmdTCPServer1AfterCommandHandler (ASender : TIdCmdTCPServer ;
      AContext : TIdContext );
  private

    { private declarations }
  public 
    { public declarations }
  end ; 

var 
  DataModule1 : TDataModule1 ; 

implementation 

{ TDataModule1 }

procedure TDataModule1.hallarIPCommand (ASender : TIdCommand );
    begin
       Asender.Reply.SetReply(301,miservidor.IP);
       ASender.SendReply;
    end;

procedure TDataModule1.apagarEquipoCommand (ASender : TIdCommand );
    const
        ORDEN_APAGAR:string='killall -9 x-session-manager;/sbin/poweroff -hp &';
    begin
        try
            Ejecutar1(ORDEN_APAGAR);
            Asender.Reply.SetReply(302,'Apagando equipo');
            ASender.SendReply;
            if IdCmdTCPServer1.Active then IdCmdTCPServer1.Active:=false;
            Application.Terminate;
        except
            writeln('Error al apagar equipo');
        end;
    end;


procedure TDataModule1.activarInternetCommand (ASender : TIdCommand );
    const
         ORDEN_ACTIVAR0:string='iptables-save| grep "owner %s"|head -1';
         ORDEN_ACTIVAR1:string='iptables %s 2>/dev/null';
    var
         datosorden:string;
         usuario:string;
    begin
        try
             if Asender.Params.Count=1 then
                 begin
                    usuario:= trim(Asender.Params[0]);
                    datosorden:=Format(ORDEN_ACTIVAR0,[usuario]);
                    datosorden:=HallarDato1(datosorden);
                    if datosorden ='' then exit;
                    datosorden:=StringReplace(datosorden, '-A ', '-D ',[rfReplaceAll]);
                    datosorden:= Format(ORDEN_ACTIVAR1,[datosorden]);
                    Ejecutar1(datosorden);
                    Asender.Reply.SetReply(304,'el usuario '+ usuario + ' tiene ya la salida internet activada');
                    ASender.SendReply;

                 end
              else
                  begin
                      writeln('Orden o número parametros incorrectos');
                  end;
        except
            writeln('Error al activar Internet');
        end;
    end;

procedure TDataModule1.desactivarInternetCommand (ASender : TIdCommand );
    const
         ORDEN_DESACTIVAR:string='iptables -I OUTPUT -p tcp --dport 23:120 -m owner --uid-owner %s -j DROP 2>/dev/null';
    var
       ordenDesactivar,usuario:string;
    begin
        try
            if Asender.Params.Count=1 then
                begin
                    usuario:= trim(Asender.Params[0]);
                    ordenDesactivar:=Format(ORDEN_DESACTIVAR,[usuario]);
                    Ejecutar1(ordenDesactivar);
                    Asender.Reply.SetReply(303,'Alumno '+ usuario +' tiene la salida a internet desactivada');
                    ASender.SendReply;
                end
            else
                begin
                    writeln('Orden o número parametros incorrectos');
                end;
        except
            writeln('Error al desactivar Internet');
        end;
    end;

procedure TDataModule1.ejecutarOrdenCommand(ASender: TIdCommand);
    begin

    end;

procedure TDataModule1.hallarConsolaCommand(ASender: TIdCommand);
    begin

    end;

procedure TDataModule1.hallarGatewayCommand (ASender : TIdCommand );
    begin
        try
             Asender.Reply.SetReply(305,miservidor.Gateway);
             ASender.SendReply;
        except
             writeln('Error al hallar gateway')
        end;
    end;

procedure TDataModule1.hallarHostCommand(ASender: TIdCommand);
    begin
        try
             Asender.Reply.SetReply(307,miservidor.Host);
             ASender.SendReply;
        except

        end;
    end;

procedure TDataModule1.hallarHostMacCommand(ASender: TIdCommand);
    var
       hostmac:string;
    begin
        try
             hostmac:=miservidor.Host+'#'+miservidor.MAC;
             Asender.Reply.SetReply(308,hostmac);
             ASender.SendReply;
        except
             writeln('Error al hallar MAC/IP');
        end;
    end;

procedure TDataModule1.hallarMACCommand (ASender : TIdCommand );
    begin
        try
             Asender.Reply.SetReply(301,miservidor.MAC);
             ASender.SendReply;
        except
             writeln('Error al hallarMAC');
        end;
    end;

procedure TDataModule1 .IdCmdTCPServer1AfterCommandHandler (
  ASender : TIdCmdTCPServer ; AContext : TIdContext );
begin

end;

initialization
  {$I demonio.lrs}
   miservidor:=Tservidor.create();
   DataModule1:=TDataModule1.create(nil);
Finalization
FreeAndNil(DataModule1);
FreeAndNil(miservidor);;

end .

